Signal Degrade Indication in Segment Routing over MPLS Network
Liuyan Han
China Mobile
Beijing
China
hanliuyan@chinamobile.com
Fan Yang
Huawei Technologies
Beijing
China
shirley.yangfan@huawei.com
Junfeng Zhao
CAICT
Beijing
China
zhaojunfeng@caict.ac.cn
8 July 2022
MPLS Working Group
Signal Degrade Indication, Segment Routing, SR
This document describes a typical use case of MPLS-TP, where signal degrade defect needs to be correctly detected and transmitted via OAM messages within network. When MPLS-TP evolves to Segment Routing MPLS, transit node has no knowledge of labels to be encapsulated in MPLS label stack. Transit node cannot spread OAM messages with signal degrade defect indication. Thus, a solution is proposed in this draft.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in RFC 2119.

Background
In early era of telecommunication, transport network is set up to provide voice service. The connection in network is always connection-oriented and circuit switching. With the rapid increasing bandwidth brought by Ethernet, transport network transforms into the packet-switched transport network. Technologies like MPLS/PWE3 perfectly meet the requirements of supporting both packet-transport and circuit-transport. It led to the work of MPLS Transport Profile (MPLS-TP), collaborated between ITU-T and IETF at the first decade of the 21st century.
MPLS-TP is a subset of MPLS. Features that are not applicable to transport network are excluded, and features to meet the requirements of transport network, e.g., bidirectional path, deterministic control and management, etc., are strictly required. According to the Joint Working Team consensus, any extension of MPLS-TP would be included in MPLS field.
With the emerge of Segment Routing (SR) and Software Defined Network (SDN), MPLS-TP network technologies are adapted as well. In this draft, we recognize one use case where the signal degrade defect can be correctly detected and transmitted via MPLS-TP OAM in MPLS-TP, but not fulfilled in SR-MPLS. To fix this problem is the motivation of this draft.
Editor's note: This section gives a historical introduction of MPLS-TP, since it has been extensively deployed in packet switched transport networks for years. The intention of this section is to help readers understand the unique of requirements from packet transport network. Once the draft becomes RFC, part of this section can be moved to Appendix.

Terminology
MPLS: MultiProtocol Label Switching
PWE3: Pseudo Wire Emulation Edge to Edge
MPLS-TP: MultiProtocol Label Switching - Transport Profile
SR: Segment Routing
SDN: Software Defined Network
OAM: Operation, Administration and Maintenance
SD: Signal Degrade
BER: Bit Error Rate
WDM: Wavelength Division Multiplexing
NMS: Network Management System
G-ACh: Generic Associated Channel
PDU: Protocol Data Unit
CCM: Continuity Check Message
MEP: Maintenance Entity Group End Point
MIP: Maintenance Entity Group Intermediate Point
AIS: Alarm Indication Signal

Problem Statement

Defect Triggered Procedure
Signal Degrade (SD) describes a status of signal associated data has degraded and a degraded defect is active. Signal degrade of a physical link is usually measured and represented by Bit Error Rate (BER) value. Fiber aging, impairment and pollution, optical module mismatch or WDM transmission error are the reasons to lead to signal degrade. More information about signal degrade can be found in [I-D.yang-mpls-ps-sdi-sr].
In practice, when physical link degrades in network, signal degrade defect is firstly detected and reported by the node. A specific type of alarm is generated and sent to Network Management System (NMS) or a SDN controller. It is a report to management plane and strongly required from perspective of network management. However, the problem is the notification to management plane is usually not fast enough to assist the network recovery. It may result in hour or even day level of service interruption time.
As mentioned in [RFC6372], defect may trigger system to perform a survivability action, when notification of an issue is reported from equipment in a lower layer, system fails to receive an OAM continuity check message, or receives of an OAM message reporting a failure condition. Similarly, when signal degrade defect is reported from the lower layer, e.g. physical layer, local protection mechanism can be triggered within the internal system of nodez. In case of protection switchover selector is at the source or destination node, while the signal degrade is happened at intermediate node, an OAM message should be transmitted to notify the degrade condition to the nodes actually perform the protection switchover. This action is preferred to be triggered by events in the data plane [RFC6372].

MPLS-TP Solution
Generic Associated Channel (G-ACh) [RFC5586] is defined to carry OAM messages for MPLS pseudowires, LSPs and sections. The Generic Associated Channel format used in MPLS is shown in Figure 1. By using the generic associated channel and indication of channel type, different OAM mechanisms with different formats can be encapsulated uniformly as well as independently.
0                   1                   2                   3
0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|              Label                    | EXP |S|      TTL      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|             GAL Label (13)            | TC  |S|      TTL      |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|0 0 0 1|Version|   Reserved    |         Channel Type          |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Figure 1 G-ACh Format in MPLS
In MPLS-TP, ITU-T G.8113.1 [ITU-T_G.8113.1] specifies a large set of OAM mechanisms and has been widely deployed in packet transport networks. Figure 2 shows the common OAM PDU format of different OAM mechanisms.
0                   1                   2                   3
0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
| MEL | Version |    OpCode     |     Flags     |  TLV Offset   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                           OAM PDU                             |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|End TLV|
+-+-+-+-+
Figure 2 ITU-T G.8113.1 Common OAM PDU Format
MEG Level: MEG Level is a 3-bit field. It contains an integer value that identifies the MEG level of OAM PDU. Value ranges from 0 to 7.
Version: Version is a 5-bit field. It contains an integer value that identifies the OAM protocol version. Value is 0 in the current version.
OpCode: OpCode is a 1-octet field. It contains an OpCode that identifies an OAM PDU type. OpCode is used to identify the remaining content of an OAM PDU. Value for the CCM PDU type is 1.
Flags: Flags is an 8-bit field. Use of the bits in this field is dependent on the OAM PDU type.
TLV Offset: TLV Offset is a 1-octet field. It contains the offset to the first TLV in an OAM PDU relative to the TLV Offset field. The value of this field is associated with an OAM PDU type. When the TLV Offset is 0, it points to the first octet following the TLV Offset field.
End TLV: an all-ZEROes octet value.
When signal degrade happens in MPLS-TP, an MPLS-TP Alarm Indication Signal (AIS) OAM message with active AIS indication is generated and transmitted within the OAM maintenance domain. Maintenance Entity Group End Point (MEP), usually also acting as protection switchover selector, performs the protection switchover once it receives the AIS indication in MPLS-TP OAM message.

Problem in SR-MPLS
When Segment Routing is introduced to MPLS, the nodes except the headend have no information of the forwarding path. If the signal degrade is happened on the transit nodes, MPLS-TP AIS OAM message cannot be generated because this node has no knowledge of labels ought to be encapsulated in MPLS label stack. Either the label information of forwarding path can be obtained on transit node, or the defect can be indicated in different messages could help the defect spread in network. It is valuable to keep transit node with the capability of reporting defects in SR-MPLS.

Solution in SR-MPLS
Segment routing is designed to reduce the states in transit nodes, any defects like SD defect cannot be indicated in a newly generated OAM message on transit node. Alternative way is to indicate the defect in other OAM messages. Continuity Check Message (CCM) is proposed to indicate the signal degrade defect for two reasons. Firstly, CCM is designed to be applicable for fault management, performance monitoring, or protection switching applications. Secondly, consider the merit of CCM's various transmission period, the defect indication can be flexibly transmitted according to operator's needs.
One reservation bits in Flag section in CCM OAM PDU message can be used as Error Indication (EI) to indicate signal degrade. Flag format with EI extension is shown in Figure 3.
MSB                           LSB
  0
  0   1   2   3   4   5   6   7
+---+---+---+---+---+---+---+---+
|RDI| EI| Reserved  |  Period   |
+---+---+---+---+---+---+---+---+
Figure 3 CCM OAM PDU Flags Format with EI Extension
RDI: Remote Defect Indication, set to 1 to indicate RDI, otherwise it is set to 0.
Period: Indicate the transmission period.
EI: Error indication, 0 indicates no error, 1 indicates error.
Reserved: Reserved fields are set to all ZEROes.
If the node detects the signal degrade defect, EI field is set in CCM OAM message and transmitted to other nodes. Note that, Maintenance Entity Group Intermediate Point (MIP) is required to be transparent to CCM message in MPLS-TP. In order to support BER indication on each node along the forwarding path, extra configuration and intervening implementation to process CCM message would be required on MIP.
Editor's Note: When other OAM mechanisms used in generic associated channel (G-ACh), there might be various solutions to transmit signal degrade defect, or any other defects detected by transit nodes. This draft introduces a very light-weight solution, which has already been implemented and deployed in networks.

IANA Considerations
This document requests IANA to assign one bit from Flags of MPLS-TP OAM PDU format to indicate "Signal Degrade".

Security Considerations
There are MEP and MIP node defined in OAM mechanisms. Some types of OAM message are defined to be transparent to MIP node, and requires no extra configuration or message processing on MIP nodes. If the transit node of SR-MPLS acts as MIP in OAM maintenance domain, this MIP node needs to process the OAM messages to indicate the defects. At the moment, explicit configuration is required on MIP to have the authority to process OAM messages.

Acknowledgements
The authors want to thank Yuanlong Jiang, Mach Chen, Yongjian Hu for their valuable suggestions during the construction of draft.

Normative References

Informative References
[ITU-T_G.8113.1]

G.8113.1: Operations, administration and maintenance mechanisms for MPLS-TP in packet transport networks
ITU-T
ITU-T
April 2016
[I-D.yang-mpls-ps-sdi-sr]
[RFC6372]
[RFC5586]